 <?php
class Freshmail_Subscription_Block_Popup
    extends Mage_Core_Block_Abstract
    implements Mage_Widget_Block_Interface
{
    
    protected $cCount;
    protected $cTime;
    
    public function _construct()
    {
        Mage::app()->cleanCache(array(Mage_Cms_Model_Block::CACHE_TAG));
    }
    
    /**
     * check if cookie exist
     * 
     * @return boolen
     */
    public function checkNewsletterCookie(){
        
        /*widgeta mozna wyswietlic gdy ciasteczko nie jest ustawione lub uzytkownik juz sie zapisal*/
        if (!isset($_COOKIE['freshmail']) || $_COOKIE['freshmail'] != 'success') {
            /*pobieramy dane z ustawien*/
            $fCount = Mage::getStoreConfig("subscription/general/popup_count");
            $fTime = Mage::getStoreConfig("subscription/general/popup_time");
            
            /*pobieramy dane ciasteczek*/
            $cTime = isset($_COOKIE['freshmail_time'])? $_COOKIE['freshmail_time'] : '0';
            $cCount = isset($_COOKIE['freshmail_count'])? $_COOKIE['freshmail_count'] : '0';

            /*jesli maksymalna ilosc wyswietlen nie zostala przekroczona a minimalny czas tak to wyswietlamy popupa*/
            if($cCount < $fCount && time() > ($cTime + ($fTime * 60))) {
                $this->cTime = time();
                $this->cCount = $cCount;
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
        
    }

    /**
     * display popup
     *
     * @return string
     */
    protected function _toHtml()
    {

        if ($this->checkNewsletterCookie()) {
            $customFields = '';
            $html = '
            <div id="freshmail-modal-backdrop" style="display:none;z-index:99998;opacity: 0.8;position:fixed;top:0;left:0;bottom:0;right:0;background: #656565;"></div>
            <div id="freshmail-modal" style="display:none;z-index:99999;background:#fff;display:block;position:fixed;top:10%;left:50%;width:940px;margin-left:-470px;height:80%;border: 1px solid rgba(0, 0, 0, 0.3);border-radius:15px;">
            <button id="freshmail-modal-button" type="button" style="cursor:pointer;position:absolute;top:-18px;right:-18px;width:36px;height:36px;background:#fff;color:#000;font-weight:600;border-radius:18px;">
                ×
            </button>
            <div style="position:absolute;display:block;top:0;left:0;bottom:0;right:0;overflow:hidden;">
                <div style="position:absolute;top:10px;left:10px;right:10px;height:55px;">
                     <div>
                            ' . Mage::getStoreConfig("subscription/general/popup_title") . '
                    </div>
                    <hr>
                </div>
                <div style="padding:10px;overflow-y: auto; opacity: 1;position:absolute;top:70px;left:10px;bottom:20px;right:10px;" class="freshContent" tabindex="5000">
                    <div>
                        <div style="float:left;clear:left;overflow:hidden;">
                            ' . Mage::getStoreConfig("subscription/general/popup_text") . '
                        </div>
                        <div style="float:left;clear:left;overflow:hidden;">
                            <div style="display:none;text-align:left;" id="fmsgContener""><span id="fmsg"></span></div>
                            <form id="freshmail-popup-newsletter-form" action="' . $this->getUrl('subscription/index/popup') . '" method="post" style="margin-top:10px;text-align:left;">
                            <fieldset style="border: none">
                                <input type="hidden" name="action" value="freshmail_newsletter_subscribe_action" />
                                <p><label for="email">Adres email</label><br /><input type="text" name="email" /></p>
                            
                                ' . $customFields . '
                            
                                <input type="submit" value="Zapisz" />
                            </fieldset>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <script type="text/javascript">
    
            document.observe("dom:loaded", function(){
            
            
            /***************************obsluga powiadomien*****************************/
            function showNewsletterMessage(msg, hide) {
                
                $("fmsg").update(msg);
                Effect.SlideDown("fmsgContener");
                
                if (hide) {
                    window.setTimeout(function() {
                        Effect.BlindUp("fmsgContener");
                    }, 7000);
                }
            }
            
            
            
            /***************************obsluga formularza(ajax)*****************************/
            Event.observe("freshmail-popup-newsletter-form", "submit", function(event) {
               
                $("freshmail-popup-newsletter-form").request({
                      onCreate:function() {
                          $$("#freshmail-popup-newsletter-form input").each(function(element) {
                              element.setAttribute("disabled", "disabled");
                          });
                      },
                      onSuccess: function(data) {
                                var response = data.responseText.evalJSON();
                                if(data.status == "200" && response.status == "success") {
                                    //jesli sie udalo to ukryj popup i ustaw cookie
                                    $("freshmail-modal-backdrop").fade({ duration: 0.5 });
                                    $("freshmail-modal").fade({ duration: 0.5 });
                                    fCookie.set("freshmail","success",365);
                                } else if(data.status == "200" && data.responseText != "success"){
                                    showNewsletterMessage(response.message, true);
                                } else {
                                    showNewsletterMessage("Wystąpił błąd. Serwer zwrócił nieznaną odpowiedź.", true);
                                }
                                $$("#freshmail-popup-newsletter-form input").each(function(element) {
                                    element.removeAttribute("disabled");
                                });
                            }
                });
                Event.stop(event); // stop the form from submitting
            });
    
    
    
    
            /***************************okna*****************************/
            $("freshmail-modal-backdrop", "freshmail-modal-button").invoke("observe", "click", function() {
                $("freshmail-modal-backdrop").fade({ duration: 0.5 });
                $("freshmail-modal").fade({ duration: 0.5 });
            });
    
            $("freshmail-modal-backdrop").appear({ duration: 0.5, from: 0, to: 0.7 });
            $("freshmail-modal").appear({ duration: 0.5, from: 0, to: 1 });
    
    
    
            /***************************obsluga ciasteczek*****************************/
            var Cookies = Class.create({
                initialize: function(path, domain) {
                    this.path = path || "/";
                    this.domain = domain || null;
                },
                // Sets a cookie
                set: function(key, value, days) {
                    if (typeof key != "string") {
                        throw "Invalid key";
                    }
                    if (typeof value != "string" && typeof value != "number") {
                        throw "Invalid value";
                    }
                    if (days && typeof days != "number") {
                        throw "Invalid expiration time";
                    }
                    var setValue = key+"="+escape(new String(value));
                    if (days) {
                        var date = new Date();
                        date.setTime(date.getTime()+(days*24*60*60*1000));
                        var setExpiration = "; expires="+date.toGMTString();
                    } else var setExpiration = "";
                    var setPath = "; path="+escape(this.path);
                    var setDomain = (this.domain) ? "; domain="+escape(this.domain) : "";
                    var cookieString = setValue+setExpiration+setPath+setDomain;
                    document.cookie = cookieString;
                }
            });
            
            var fCookie = new Cookies();
            fCookie.set("freshmail","fail",30);
            fCookie.set("freshmail_count", "' . ($this->cCount+1) . '", 30);
            fCookie.set("freshmail_time", ' . $this->cTime . ', 30);
            
            });
        </script>';
    } else {
        $html = '';
    }
        
        return $html;
    }
} 