<?php
class Freshmail_Subscription_Model_Cron extends Varien_Object
{
    /**
     * synchronizacja listy subskrybcyjnej z magento do freshmaila wraz z parametrami dodatkowymi
     * 
     * @return null
     */
    static public function sync()
    {
        Mage::helper('subscription')->log('Cron');
        require_once(BP . DS .'lib/Subscription/FmRestApi.php');

        if(Mage::helper('subscription')->checkAuth()) {
            $fm = new FmRestApi();
            $fm->setApiKey(Mage::getStoreConfig('subscription/general/api_key'));
            $fm->setApiSecret(Mage::getStoreConfig('subscription/general/api_secret'));
            
            Mage::helper('subscription')->checkCustomFields($fm);
                
            try {
                $collection = Mage::getModel('newsletter/subscriber')->getCollection();
                foreach ($collection as $item) {
                    $cFields = array();
                    if(!empty($item['customer_id'])) {
                        $customer_data = Mage::getModel('customer/customer')->load($item['customer_id']);
                        $mFields = unserialize(Mage::getStoreConfig('subscription/general/custom_fields'));
                        
                        $customer_data = $customer_data->get();
                        foreach($mFields as $mField) {
                            $cFields[strtolower($mField['freshmail'])] = $customer_data[$mField['magento']];
                        }
                    }
                
                    $rfm = Mage::helper('subscription')->getRFM($item['subscriber_email']);
                    $cFields['fma_r'] = $rfm['r'];
                    $cFields['fma_f'] = $rfm['f'];
                    $cFields['fma_m'] = $rfm['m'];
                
                    $status = Mage::helper('subscription')->getFreshmailStatus($item['subscriber_status']);
                    try {
                        $data = array(
                            'email' => $item['subscriber_email'],
                            'list'  => Mage::helper('subscription')->hash,
                            'custom_fields' => $cFields
                        );
                        $fm->doRequest('subscriber/edit', $data);
                    } catch (exception $e) {
                        $errors = $fm->getErrors();
                        $add = 0;
                        if (is_array($errors)) {
                            foreach ($errors as $error) {
                                if($error['code'] == 1331 ) $add = 1;
                            }
                        }
                        if($add){
                            try {
                                $data['confirm'] = '0';
                                $fm->doRequest('subscriber/add', $data);
                            } catch (exception $e) {
                                Mage::helper('subscription')->log(array($item['subscriber_email'], print_r($fm->getErrors(),true)));
                                continue;
                            }
                        } else{
                            Mage::helper('subscription')->log(array($item['subscriber_email'], print_r($fm->getErrors(),true)));
                            continue;
                        }
                    }
                }
            } catch (exception $e) {
                Mage::helper('subscription')->log(print_r($e,true));
            }
        }
    }
}
